## gr-funcube 1.0.0

=== CMakeLists.txt ===
# Copyright 2011,2012,2014,2016,2018 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.8)
project(gr-funcube CXX C)
enable_testing()

# Install to PyBOMBS target prefix if defined
if(DEFINED ENV{PYBOMBS_PREFIX})
    set(CMAKE_INSTALL_PREFIX $ENV{PYBOMBS_PREFIX})
    message(STATUS "PyBOMBS installed GNU Radio. Setting CMAKE_INSTALL_PREFIX to $ENV{PYBOMBS_PREFIX}")
endif()

# Select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

# Make sure our local CMake Modules path comes first
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

# Set the version information here
set(VERSION_MAJOR 1)
set(VERSION_API   0)
set(VERSION_ABI   0)
set(VERSION_PATCH 0)

cmake_policy(SET CMP0011 NEW)

# Enable generation of compile_commands.json for code completion engines
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

########################################################################
# Compiler specific setup
########################################################################
if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()

IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_CXX_STANDARD 11)
ELSEIF(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_STANDARD 11)
ELSEIF(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_CXX_STANDARD 11)
ELSE()
    message(WARNING "C++ standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()

IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_C_STANDARD 11)
ELSE()
    message(WARNING "C standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()
########################################################################
# Find funcube dependencies
########################################################################
if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    find_package(USB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb required to compile funcube modules")
    else()
        message(STATUS "Using libusb: ${LIBUSB_LIBRARIES} ")
    endif()
    find_package(HIDAPI )
    if(NOT LIBHIDAPI_FOUND)
        message(FATAL_ERROR "hidapi libs required to compile the funcube modules")
    else()
        message(STATUS "Using Hidapi: ${LIBHIDAPI_LIBRARIES} ")
    endif()
endif()

########################################################################
# Install directories
########################################################################
find_package(Gnuradio "3.9" REQUIRED audio blocks)
include(GrVersion)

include(GrPlatform) #define LIB_SUFFIX

if(NOT CMAKE_MODULES_DIR)
  set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

set(GR_INCLUDE_DIR      include/funcube)
set(GR_CMAKE_DIR        ${CMAKE_MODULES_DIR}/funcube)
set(GR_PKG_DATA_DIR     ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Find gnuradio build dependencies
########################################################################
find_package(Doxygen)

########################################################################
# PyBind11 Related
########################################################################

find_package(pybind11 REQUIRED)
execute_process(
    COMMAND "${PYTHON_EXECUTABLE}" -c
    "try:\n import numpy\n import os\n inc_path = numpy.get_include()\n if os.path.exists(os.path.join(inc_path, 'numpy', 'arrayobject.h')):\n  print(inc_path, end='')\nexcept:\n pass"
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR)

########################################################################
# Setup doxygen option
########################################################################
if(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" ON)
else(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" OFF)
endif(DOXYGEN_FOUND)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/funcube)
add_subdirectory(lib)
add_subdirectory(apps)
add_subdirectory(docs)
add_subdirectory(python)
add_subdirectory(grc)

########################################################################
# Install cmake search helper for this library
########################################################################

install(FILES cmake/Modules/funcubeConfig.cmake
    DESTINATION ${CMAKE_MODULES_DIR}/funcube
)

=== python/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Include python install macros
########################################################################
include(GrPython)
if(NOT PYTHONINTERP_FOUND)
    return()
endif()

add_subdirectory(bindings)

########################################################################
# Install python sources
########################################################################
GR_PYTHON_INSTALL(
    FILES
    __init__.py
    DESTINATION ${GR_PYTHON_DIR}/funcube
)

########################################################################
# Handle the unit tests
########################################################################
include(GrTest)

set(GR_TEST_TARGET_DEPS gnuradio-funcube)
GR_ADD_TEST(qa_fcd_control ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcd_control.py)
GR_ADD_TEST(qa_fcd ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcd.py)
GR_ADD_TEST(qa_fcdpp_control ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcdpp_control.py)
GR_ADD_TEST(qa_fcdpp ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcdpp.py)

=== docs/doxygen/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Create the doxygen configuration file
########################################################################
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} top_builddir)
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} abs_top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} abs_top_builddir)

set(HAVE_DOT ${DOXYGEN_DOT_FOUND})
set(enable_html_docs YES)
set(enable_latex_docs NO)
set(enable_xml_docs YES)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
@ONLY)

set(BUILT_DIRS ${CMAKE_CURRENT_BINARY_DIR}/xml ${CMAKE_CURRENT_BINARY_DIR}/html)

########################################################################
# Make and install doxygen docs
########################################################################
add_custom_command(
    OUTPUT ${BUILT_DIRS}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with doxygen"
)

add_custom_target(doxygen_target ALL DEPENDS ${BUILT_DIRS})

install(DIRECTORY ${BUILT_DIRS} DESTINATION ${GR_PKG_DOC_DIR})

=== python/bindings/CMakeLists.txt ===
# Copyright 2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

GR_PYTHON_CHECK_MODULE_RAW(
    "pygccxml"
    "import pygccxml"
    PYGCCXML_FOUND
    )

include(GrPybind)

########################################################################
# Python Bindings
########################################################################

list(APPEND funcube_python_files
    fcd_control_python.cc
    fcd_python.cc
    fcdpp_control_python.cc
    fcdpp_python.cc python_bindings.cc)

GR_PYBIND_MAKE_OOT(funcube 
   ../..
   gr::funcube
   "${funcube_python_files}")

install(TARGETS funcube_python DESTINATION ${GR_PYTHON_DIR}/funcube COMPONENT pythonapi)

=== debian/changelog ===
gr-funcube (1.0.0-3build1) jammy; urgency=medium

  * No-change rebuild against gnuradio 3.10.1

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 08 Feb 2022 13:58:32 +0000

gr-funcube (1.0.0-3) unstable; urgency=medium

  * update logging (Closes: #1003990)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 18 Jan 2022 20:45:47 -0500

gr-funcube (1.0.0-2) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 18 Dec 2021 08:03:21 -0500

gr-funcube (1.0.0-1) experimental; urgency=medium

  * New upstream release v1.0.0
  * [11746ac] Fixing python lib name in tests and setting GR_TEST_PYTHON_DIRS
  * for gnuradio 3.9

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 10 Nov 2021 18:14:09 -0500

gr-fcdproplus (3.8~20190817-3) unstable; urgency=medium

  * depend upon dh-python since python3-dev no longer does
  * also add depends on liborc-0.4-dev (Closes: #948937)
    thanks peter!

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 15 Jan 2020 00:06:08 -0500

gr-fcdproplus (3.8~20190817-2) unstable; urgency=medium

  * new watch file. Thanks Kali folk! (Closes: #888853)
  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 28 Aug 2019 19:08:56 -0400

gr-fcdproplus (3.8~20190817-1) experimental; urgency=medium

  * New upstream 3.8 port

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Aug 2019 21:03:19 -0400

gr-fcdproplus (3.7.25.4b6464b-5) unstable; urgency=medium

  * add breaks/replaces line to hint upgrade (Closes: #875875)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Sep 2017 03:25:39 -0400

gr-fcdproplus (3.7.25.4b6464b-4) unstable; urgency=medium

  * install .pc file correctly (Closes: #875436)
  * install AppStream metainfo.xml file

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 14 Sep 2017 17:56:18 -0400

gr-fcdproplus (3.7.25.4b6464b-3) unstable; urgency=medium

  * build with gnuradio 3.7.10

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 04 Sep 2017 00:02:30 -0400

gr-fcdproplus (3.7.25.4b6464b-2) unstable; urgency=medium

  * Breaks/Replaces older library packages (Closes: #830754, #830787)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 11 Jul 2016 21:41:09 -0400

gr-fcdproplus (3.7.25.4b6464b-1) unstable; urgency=medium

  * v3.7.2-rc1-6-g4b6464b
  * build with gnuradio 3.7.10

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 09 Jul 2016 17:01:59 -0400

gr-fcdproplus (3.7.24.cf5db38-5) unstable; urgency=medium

  * build with gnuradio 3.7.9

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 08 Jan 2016 00:10:43 -0500

gr-fcdproplus (3.7.24.cf5db38-4) unstable; urgency=medium

  * Lintian packaging cleanups

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 27 Nov 2015 21:24:48 -0500

gr-fcdproplus (3.7.24.cf5db38-3) unstable; urgency=low

  * post gcc-5 rebuild with gnuradio 3.7.8-3 (Closes: #791060)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 12 Sep 2015 21:45:22 -0400

gr-fcdproplus (3.7.24.cf5db38-2) unstable; urgency=low

  * update hid code for kFreeBSD case.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 16 Aug 2015 16:11:03 -0400

gr-fcdproplus (3.7.24.cf5db38-1) unstable; urgency=low

  * New upstream with_hidapi-10-gcf5db38
    24 patches after v3.7 tag

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Aug 2015 23:54:00 -0400

gr-fcdproplus (3.7.11-3) unstable; urgency=low

  * include Version in pkg-config pc file. (Closes: #759510)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 03 Sep 2014 16:27:13 -0400

gr-fcdproplus (3.7.11-2) unstable; urgency=low

  * build with gnuradio 3.7.5

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 03 Sep 2014 01:50:28 -0400

gr-fcdproplus (3.7.11-1) unstable; urgency=low

  * Use version 3.7.11 for v3.7_hidraw-11-g1edbe52 (Closes: #757360)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 27 Aug 2014 01:26:32 -0400

gr-fcdproplus (0.0.1.2.1edbe52-2) unstable; urgency=low

  * kFreeBSD build fix for freebsd-libs 10.0-5 which has
  libusb_get_string_descriptor

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 19 Apr 2014 18:33:52 -0400

gr-fcdproplus (0.0.1.2.1edbe52-1) unstable; urgency=low

  * Update to v3.7_hidraw-11-g1edbe52

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 18 Apr 2014 21:18:23 -0400

gr-fcdproplus (0.0.1.1.2c80be-3~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 01 Feb 2014 21:42:44 -0500

gr-fcdproplus (0.0.1.1.2c80be-3) unstable; urgency=low

  * Recommend udev

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 01 Jan 2014 11:44:43 -0500

gr-fcdproplus (0.0.1.1.2c80be-2) unstable; urgency=low

  * Try kFreeBSD support

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 29 Dec 2013 09:43:37 -0500

gr-fcdproplus (0.0.1.1.2c80be-1) unstable; urgency=low

  * New upstream (Closes: #725842)
  * Upstream does not yet set a soversion, so Debian package will start from 0.

 -- A. Maitland Bottoms <bottoms@petros.rf.org>  Mon, 02 Dec 2013 12:33:26 -0500

=== debian/control ===
Source: gr-funcube
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       dh-python,
               doxygen,
               gnuradio (>=3.9),
               gnuradio-dev (>> 3.9),
               libasound2-dev,
               libboost-dev,
               libboost-filesystem-dev,
	       libboost-program-options-dev,
	       libboost-regex-dev,
               libboost-system-dev,
	       libboost-thread-dev,
	       libgmp-dev,
               libhidapi-dev,
	       libjack-dev,
               liblog4cpp5-dev,
	       liborc-0.4-dev,
	       libpulse-dev,
	       libsndfile1-dev,
               libusb-1.0-0-dev,
               pkg-config,
	       portaudio19-dev,
               python3-dev,
	       python3-numpy,
	       python3-six
Standards-Version: 4.6.0
Homepage: https://github.com/dl1ksv/gr-funcube
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/gr-funcube
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/gr-funcube.git

Package: gr-funcube
Architecture: any
Depends: ${python3:Depends},
	 libgnuradio-funcube1.0.0 (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gnuradio, gr-osmosdr, udev
Description: Funcube Dongle controller for GNU Radio
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle and Funcube Dongle Pro+ are supported
 by this package.
 .
 This package provides a Python library as well as
 a gnuradio companion source object.

Package: libgnuradio-funcube1.0.0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gr-funcube
Description: Funcube Dongle controller for GNU Radio (runtime)
 Support hardware for software radio using the fcdproplus
 which provides sampled RF IQ data as a USB audio stereo
 data stream. Control is done over USB HID protocol.
 .
 Both the Funcube Dongle and Funcube Diongle Pro+ are supported
 by this package.
 .
 This package provides a shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
GITREV=$(shell echo $(VER) | sed -rne 's,[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\.([0-9]+),\1,p')

%:
	dh $@ --with python3 --with numpy3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"

override_dh_install:
	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyc
	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyo
	dh_install

get-orig-source:
	git clone https://github.com/dl1ksv/gr-funcube
	cd gr-funcube && git archive --format=tar --prefix=gr-funcube-$(VER)/  $(GITREV) | xz > ../gr-funcube_$(VER).orig.tar.xz
	rm -rf gr-funcube

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gr-funcube_$1.orig.tar.gz%" \
 https://github.com/dl1ksv/gr-funcube/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## gr-funcube 3.10.0~rc2

=== debian/changelog ===
gr-funcube (3.10.0~rc2-3) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 23 Aug 2022 16:32:35 -0400

gr-funcube (3.10.0~rc2-2) experimental; urgency=medium

  * Fix-build-with-fmt-9.0.0 (Closes: #1017802)
  * Bump soversion to match upstream
    - upload to experimental with new libgnuradio-funcube3.10.0
  * Cleanup packaging, fix spelling
  * Update standards version to 4.6.1, no changes needed.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 21 Aug 2022 11:18:15 -0400

gr-funcube (3.10.0~rc2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Fixes FTBFS with gcc 12. (Closes: #1012940)
  * Remove debian/patches/*, they no longer apply.

 -- Christoph Berg <myon@debian.org>  Sun, 14 Aug 2022 15:06:38 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
                debhelper-compat (= 13),
 	       dh-python,
                doxygen,
-               gnuradio (>=3.9),
-               gnuradio-dev (>> 3.9),
+               gnuradio (>=3.10),
+               gnuradio-dev (>> 3.10),
                libasound2-dev,
                libboost-dev,
                libboost-filesystem-dev,
@@ -29,7 +29,7 @@
                python3-dev,
 	       python3-numpy,
 	       python3-six
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/dl1ksv/gr-funcube
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/gr-funcube
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/gr-funcube.git
@@ -37,7 +37,7 @@
 Package: gr-funcube
 Architecture: any
 Depends: ${python3:Depends},
-	 libgnuradio-funcube1.0.0 (=${binary:Version}),
+	 libgnuradio-funcube3.10.0 (=${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: gnuradio, gr-osmosdr, udev
@@ -52,8 +52,9 @@
  This package provides a Python library as well as
  a gnuradio companion source object.
 
-Package: libgnuradio-funcube1.0.0
+Package: libgnuradio-funcube3.10.0
 Architecture: any
+Section: libs
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: gr-funcube

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3 --with numpy3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"

override_dh_install:
	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyc
	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyo
	dh_install

## gr-funcube 3.10.0~rc3

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,45 +30,54 @@
 list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)
 
 # Set the version information here
-set(VERSION_MAJOR 1)
-set(VERSION_API   0)
+set(VERSION_MAJOR 3)
+set(VERSION_API   10)
 set(VERSION_ABI   0)
 set(VERSION_PATCH 0)
 
-cmake_policy(SET CMP0011 NEW)
+#find required gnuradio installation
+find_package(Gnuradio "3.10" REQUIRED audio blocks)
+include(GrVersion)
+
+#Set minimum version requirements
+include(GrMinReq)
 
 # Enable generation of compile_commands.json for code completion engines
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 ########################################################################
-# Compiler specific setup
+# Compiler settings
 ########################################################################
-if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
-    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-    AND NOT WIN32)
-    #http://gcc.gnu.org/wiki/Visibility
-    add_definitions(-fvisibility=hidden)
-endif()
 
-IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-    SET(CMAKE_CXX_STANDARD 11)
-ELSEIF(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-    SET(CMAKE_CXX_STANDARD 11)
-ELSEIF(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
-    SET(CMAKE_CXX_STANDARD 11)
+include(GrCompilerSettings)
+
+# Record Compiler Info for record
+STRING(TOUPPER ${CMAKE_BUILD_TYPE} GRCBTU)
+SET(COMPILER_INFO "")
+IF(MSVC)
+    IF(MSVC_VERSION LESS "${MSVC_MIN_VERSION}")
+        MESSAGE(FATAL_ERROR "MSVC Versions < minimum version ${MSVC_MIN_VERSION}")
+    ENDIF()
+    SET(cmake_c_compiler_version ${MSVC_VERSION})
+    SET(cmake_cxx_compiler_version ${MSVC_VERSION})
 ELSE()
-    message(WARNING "C++ standard could not be set because compiler is not GNU, Clang or MSVC.")
-ENDIF()
+    execute_process(COMMAND ${CMAKE_C_COMPILER} --version
+            OUTPUT_VARIABLE cmake_c_compiler_version)
+    execute_process(COMMAND ${CMAKE_CXX_COMPILER} --version
+            OUTPUT_VARIABLE cmake_cxx_compiler_version)
+ENDIF(MSVC)
+SET(COMPILER_INFO "${CMAKE_C_COMPILER}:::${CMAKE_C_FLAGS_${GRCBTU}} ${CMAKE_C_FLAGS}\n${CMAKE_CXX_COMPILER}:::${CMAKE_CXX_FLAGS_${GRCBTU}} ${CMAKE_CXX_FLAGS}\n" )
 
-IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
-    SET(CMAKE_C_STANDARD 11)
-ELSEIF(CMAKE_C_COMPILER_ID MATCHES "Clang")
-    SET(CMAKE_C_STANDARD 11)
-ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
-    SET(CMAKE_C_STANDARD 11)
-ELSE()
-    message(WARNING "C standard could not be set because compiler is not GNU, Clang or MSVC.")
-ENDIF()
+# Convert to a C string to compile and display properly
+string(STRIP "${cmake_c_compiler_version}" cmake_c_compiler_version)
+string(STRIP "${cmake_cxx_compiler_version}" cmake_cxx_compiler_version)
+string(STRIP ${COMPILER_INFO} COMPILER_INFO)
+MESSAGE(STATUS "Compiler Version: ${cmake_c_compiler_version}")
+MESSAGE(STATUS "Compiler Flags: ${COMPILER_INFO}")
+string(REPLACE "\n" " \\n" cmake_c_compiler_version ${cmake_c_compiler_version})
+string(REPLACE "\n" " \\n" cmake_cxx_compiler_version ${cmake_cxx_compiler_version})
+string(REPLACE "\n" " \\n" COMPILER_INFO ${COMPILER_INFO})
+
 ########################################################################
 # Find funcube dependencies
 ########################################################################
@@ -90,8 +99,6 @@
 ########################################################################
 # Install directories
 ########################################################################
-find_package(Gnuradio "3.9" REQUIRED audio blocks)
-include(GrVersion)
 
 include(GrPlatform) #define LIB_SUFFIX

=== apps/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPython)

GR_PYTHON_INSTALL(
    PROGRAMS
    DESTINATION bin
)

=== docs/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
find_package(Doxygen)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_DOXYGEN)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(doxygen)

endif(ENABLE_DOXYGEN)

=== grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES
    funcube_fcd.block.yml
    funcube_fcd_control.block.yml
    funcube_fcdpp.block.yml
    funcube_fcdpp_control.block.yml DESTINATION share/gnuradio/grc/blocks
)

=== lib/CMakeLists.txt ===
# Copyright 2011,2012,2016,2018,2019 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX

list(APPEND funcube_sources
    fcd_impl.cc
    fcd_control_impl.cc
    fcdpp_impl.cc
    fcdpp_control_impl.cc
)

set(funcube_sources "${funcube_sources}" PARENT_SCOPE)
if(NOT funcube_sources)
    MESSAGE(STATUS "No C++ sources... skipping lib/")
    return()
endif(NOT funcube_sources)
list(APPEND funcube_libs ${LIBUSB_LIBRARIES} ${LIBHIDAPI_LIBRARIES})

add_library(gnuradio-funcube SHARED ${funcube_sources} )
target_link_libraries(gnuradio-funcube gnuradio::gnuradio-runtime gnuradio::gnuradio-audio gnuradio::gnuradio-blocks ${funcube_libs})
target_include_directories(gnuradio-funcube
    PRIVATE ${LIBHIDAPI_INCLUDE_DIR}
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PUBLIC $<INSTALL_INTERFACE:include>
  )
set_target_properties(gnuradio-funcube PROPERTIES DEFINE_SYMBOL "gnuradio_funcube_EXPORTS")

if(APPLE)
    set_target_properties(gnuradio-funcube PROPERTIES
        INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
    )
endif(APPLE)

########################################################################
# Install built library files
########################################################################
include(GrMiscUtils)
GR_LIBRARY_FOO(gnuradio-funcube)

########################################################################
# Print summary
########################################################################
message(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Building for version: ${VERSION} / ${LIBVER}")

########################################################################
# Build and register unit test
########################################################################

find_package(Boost  REQUIRED
     OPTIONAL_COMPONENTS unit_test_framework)

if( Boost_unit_test_framework_FOUND )              
    include(GrTest)

    # If your unit tests require special include paths, add them here
    #include_directories()
    # List all files that contain Boost.UTF unit tests here
    list(APPEND test_funcube_sources
    qa_fcdpp.cc
    qa_fcdpp_control.cc
    qa_fcd.cc
    qa_fcd_control.cc
    )
    # Anything we need to link to for the unit tests go here
    list(APPEND GR_TEST_TARGET_DEPS gnuradio-funcube)

    if(NOT test_funcube_sources)
        MESSAGE(STATUS "No C++ unit tests... skipping")
        return()
    endif(NOT test_funcube_sources)

    foreach(qa_file ${test_funcube_sources})
    GR_ADD_CPP_TEST("funcube_${qa_file}"
        ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file}
    )
   endforeach(qa_file)
else()
   message(STATUS " boost unit_test_framework is missing, so no tests will be generated")
endif()

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
 include(GrTest)
 
 set(GR_TEST_TARGET_DEPS gnuradio-funcube)
+set(GR_TEST_PYTHON_DIRS ${CMAKE_BINARY_DIR}/python/bindings)
 GR_ADD_TEST(qa_fcd_control ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcd_control.py)
 GR_ADD_TEST(qa_fcd ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcd.py)
 GR_ADD_TEST(qa_fcdpp_control ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/qa_fcdpp_control.py)

=== include/funcube/CMakeLists.txt ===
# Copyright 2011,2012 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-funcube
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install public header files
########################################################################
install(FILES
    api.h
    fcd.h
    fcd_control.h
    fcdpp.h
    fcdpp_control.h DESTINATION include/funcube
)

=== debian/changelog ===
gr-funcube (3.10.0~rc3-4) unstable; urgency=medium

  [ A.Maitland Bottoms ]
  * clean up after Doxygen (Closes: #1044735)

  [ Janitor ]
  * update Standards-Version to 4.6.2
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 24 Feb 2024 18:15:35 -0500

gr-funcube (3.10.0~rc3-3) unstable; urgency=medium

  * expect some python tests to fail

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 19 Jul 2023 23:00:54 -0400

gr-funcube (3.10.0~rc3-2) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 18 Sep 2022 08:03:00 -0400

gr-funcube (3.10.0~rc3-1) experimental; urgency=medium

  * New upstream release
  * Go ahead and update library name with soversion
    for clean upgrade path (Closes: #1018773).
  * Register gr-funcube HTML documentation with doc-base
  * patch to ensure CMake library helpers get installed with gnuradio
  * update Standards-Version to 4.6.1
  * upload to experimental for ABI bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Sep 2022 11:18:25 -0400

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
                debhelper-compat (= 13),
 	       dh-python,
                doxygen,
-               gnuradio (>=3.10),
-               gnuradio-dev (>> 3.10),
+               gnuradio (>=3.9),
+               gnuradio-dev (>> 3.9),
                libasound2-dev,
                libboost-dev,
                libboost-filesystem-dev,
@@ -19,17 +19,15 @@
 	       libgmp-dev,
                libhidapi-dev,
 	       libjack-dev,
-               liblog4cpp5-dev,
 	       liborc-0.4-dev,
 	       libpulse-dev,
 	       libsndfile1-dev,
                libusb-1.0-0-dev,
-               pkg-config,
+               pkgconf,
 	       portaudio19-dev,
                python3-dev,
-	       python3-numpy,
-	       python3-six
-Standards-Version: 4.6.1
+	       python3-numpy
+Standards-Version: 4.6.2
 Homepage: https://github.com/dl1ksv/gr-funcube
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/gr-funcube
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/gr-funcube.git
@@ -53,8 +51,8 @@
  a gnuradio companion source object.
 
 Package: libgnuradio-funcube3.10.0
+Section: libs
 Architecture: any
-Section: libs
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: gr-funcube

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,10 @@
 override_dh_auto_configure:
 	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_BUILD_TYPE="Release"
 
-override_dh_install:
-	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyc
-	rm -f debian/tmp/usr/lib/python3/dist-packages/funcube/*.pyo
-	dh_install
+override_dh_auto_test:
+	- dh_auto_test
+
+override_dh_auto_clean:
+	rm -rf docs/doxygen/doxyxml/__pycache__
+	rm -rf docs/doxygen/doxyxml/generated/__pycache__
+	dh_auto_clean $@
